
BankAccount subclass: #ChargeAccount
  instanceVariableNames: 
    'paymentsForMonth previousBalance '
  classVariableNames: 
    'FinanceChargeRate CreditLimit '
  poolDictionaries: ''    !


!ChargeAccount class methods !
   
creditLimit: aNumber
    CreditLimit:= aNumber!

fileInOn: aStream
"Inputs the charge account's data from aStream."
    | account |
    account := self new.
    account
        previousBalance: aStream nextLine asFloat;
        paymentsForMonth: aStream nextLine asFloat.
    ^account!
 
financeChargeRate: aNumber
    FinanceChargeRate := aNumber!
   
new
    ^super new init! !



!ChargeAccount methods !
 
asString
    ^(super asString, '   previous balance: ',
                                         previousBalance asDollarsAndCents,
                                '\', '   payments for month: ',
                                         paymentsForMonth asDollarsAndCents, '\') withCrs!
  
deposit: aNumber
    super deposit: aNumber.
    paymentsForMonth := paymentsForMonth + aNumber!
  
fileOutOn: aStream
"Outputs the charge account's data to aStream."
    aStream
        nextPutAll: self class name; cr;
        nextPutAll: previousBalance printString; cr;
        nextPutAll: paymentsForMonth printString; cr.
    super fileOutOn: aStream!
  
init
    super init.
    paymentsForMonth:= 0.00.
    previousBalance := 0.00.
    CreditLimit isNil ifTrue: [CreditLimit := 2000.00].
    FinanceChargeRate isNil ifTrue: [FinanceChargeRate := 0.18].!
   
monthlyChargeOrInterest
    | charge |
    charge := ((previousBalance + paymentsForMonth) min: 0)
        * FinanceChargeRate / 12.
    balance := balance + charge.
    paymentsForMonth := 0!
   
paymentsForMonth: aValue
    paymentsForMonth := aValue!
   
previousBalance: aValue
    previousBalance := aValue!
 
withDraw: aNumber
    (balance - aNumber) < (-1 * CreditLimit)
        ifTrue: [^'not accepted'].
    balance := balance - aNumber.
    ^'accepted'! !
