
ViewManager subclass: #TextAnalyzer
  instanceVariableNames: 
    'fileName text wordTable wordCount averageWordLength '
  classVariableNames: ''
  poolDictionaries: 
    'ColorConstants WBConstants ' !


!TextAnalyzer class methods !

example
    self new open!
 
wbCreated

    ^true! !



!TextAnalyzer methods !

computeStats
"Computes statistics for file."
    | aReadStream word characterCount|
    aReadStream := ReadStream on: text.
    wordTable := Dictionary new.
    wordCount := 0.
    characterCount := 0.
    word := aReadStream nextWord.
    [word isNil] whileFalse:[
        word := word asUpperCase.
        wordTable at: word
            put: ((wordTable at: word ifAbsent: [0]) + 1).
        wordCount := wordCount + 1.
        characterCount := characterCount + word size.
        word := aReadStream nextWord].
    characterCount = 0
        ifTrue: [averageWordLength := 0]
        ifFalse: [averageWordLength := (characterCount / wordCount)
            roundTo: 0.01]!

createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Text Analyzer';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1143 @ 512; xC; yC; cRDU: (9 @ 504 rightBottom: 1134 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 64; lDU: 133 r: #left; rDU: 325 r: #left; tDU: 392 r: #top; bDU: 456 r: #top);
                    startGroup;
                    when: #clicked perform: #openFile:;
                    contents: 'Open File';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 64; lDU: 681 r: #left; rDU: 946 r: #left; tDU: 392 r: #top; bDU: 456 r: #top);
                    startGroup;
                    when: #clicked perform: #saveStatistics:;
                    contents: 'Save Statistics';
                    yourself
            );
            addSubpane: (
                TextPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 457 @ 376; lDU: 0 r: #left; rDU: 457 r: #left; tDU: 8 r: #top; bDU: 384 r: #top);
                    startGroup;
                    when: #getContents perform: #displayText:;
                    yourself
            );
            addSubpane: (
                TextPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 622 @ 376; lDU: 503 r: #left; rDU: 1125 r: #left; tDU: 8 r: #top; bDU: 384 r: #top);
                    startGroup;
                    when: #getContents perform: #displayStats:;
                    yourself
            );
        yourself
    ).!
  
displayStats: aPane
"Obtains statistics from text and displays them in text pane."
    text isNil
        ifTrue: [aPane contents: String new]
        ifFalse: [
            aPane contents: String new.
            self statsToStream: aPane]!
 
displayText: aPane
"Displays text of file in text pane."
    aPane contents: text!

open
"Opens a window on a text analyzer."
    super open!
 
openFile: aPane
"Opens text file and analyzes it."
    | dialog  fileStream |
    dialog := FileDialog new.		"Start of step 1."
    dialog
        title: 'Open any file to analyze';
        addFilter: '*.*' description: 'Any files (*.*)';
        defFilter: '*.*';
        defExtension: ''.
    fileName := dialog open file.
    fileName isNil
        ifTrue: [^nil].
    CursorManager execute change.
    fileStream := File pathName: fileName.
    text := fileStream contents.
    fileStream close.
    self computeStats.
    CursorManager normal change.
    self
        changed: #displayText:;
        changed: #displayStats:!
   
saveStatistics: aPane
"Saves statistics to a file."
    | dialog name fileStream |
    fileName isNil ifTrue: [^Menu message: 'No file analyzed'].
    dialog := FileDialog new.
    dialog
        title: 'Save statistics to file';
        addFilter: '*.*' description: 'Any files (*.*)';
        defFilter: '*.*';
        defExtension: ''.
    name := dialog save file.
    name isNil
        ifTrue: [^nil].
    CursorManager execute change.
    fileStream := File newFile: name.
    self statsToStream: fileStream.     "Same method used in statsText:."
    fileStream truncate; close.
    CursorManager normal change!
 
statsToStream: aStream
"Outputs statistics to a stream."
    aStream
        nextPutAll: 'File name: ', fileName; cr;
        nextPutAll: 'Total number of words: ',
        wordCount printString; cr;
        nextPutAll: 'Average length of a word: ',
        averageWordLength printString; cr.
    wordTable keys asSortedCollection do: [:key |
        aStream nextPutAll: key, ' -- ' , (wordTable at: key) printString; cr]! !
