
ViewManager subclass: #ChartInterface
  instanceVariableNames: 
    'gradesDictionary '
  classVariableNames: ''
  poolDictionaries: 
    'ColorConstants WBConstants '  !


!ChartInterface class methods !
  
example1

    "    ChartInterface example1    "

    | dictionary |
    dictionary := Dictionary new.
    dictionary at: 'A grades' put: 0.40.
    dictionary at: 'B grades' put: 0.30.
    dictionary at: 'C grades' put: 0.20.
    dictionary at: 'D grades' put: 0.10.
    dictionary at: 'F grades' put: 0.00.
    self new openOn: dictionary label: 'Grades'!
  
wbCreated

    ^true! !



!ChartInterface methods !
  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  '';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 933 @ 608; lDU: 391 r: #left; tDU: 330 r: #top; cRDU: (400 @ 930 rightBottom: 1314 @ 376));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #close perform: #onClose:;
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 869 @ 530; xC; yC);
                    paneName: 'canvas';
                    noBorders;
                    startGroup;
                    when: #getContents perform: #displayGraph:;
                    yourself
            );
        yourself
    ).!

displayGraph: aPane
"Sets up pie chart and display it in the graph pane"

    | position pen startAngle sweepAngle major minor percent count colors i |

    colors := OrderedCollection with: ClrYellow with: ClrPink with: ClrPalegray with: ClrGreen.
    colors add: ClrCyan.

                    "To see what colors are available execute  ---  ColorConstants inspect   "

    pen := aPane pen.
    count := 0.
    startAngle := 0.
    major := 180.
    minor := 180.
    pen drawRetainPicture: [
        i := 0.
        gradesDictionary keys do: [:key |
            i := i+1.
            percent := gradesDictionary at: key.
            percent > 0 ifTrue: [
                sweepAngle := 360 * percent.
                pen
                    home;
                    backColor: (colors at: i);
                    pieFilled: major
                          minor: minor
                          angles: startAngle @ sweepAngle;
                    up;
                    direction: 0;
                    turn: startAngle + 30.
                (startAngle <= 180 and: [startAngle > 0])
                    ifTrue: [pen go: 150]
                    ifFalse: [pen go: 40].
                pen
                    down;
                    displayText: key, ' ',(percent * 100) printString, ' ',  '%'.
                startAngle := startAngle + sweepAngle]]]!
   
onClose: aPane
"Releases segments and closes window."
    (self paneNamed: 'canvas' ) pen deleteAllSegments.
    self close!
 
openOn: aDictionary label: label
"Opens a window on a pie chart."
    gradesDictionary := aDictionary.
    super open.
    self labelWithoutPrefix: label! !
