
ViewManager subclass: #ShapeDemo
  instanceVariableNames: 
    'anchorPoint lastPosition boxColl '
  classVariableNames: ''
  poolDictionaries: 
    'ColorConstants GraphicsConstants DrawingModeConstants WBConstants WinConstants '   !


!ShapeDemo class methods !
   
example1

    "    ShapeDemo example1   "

    self new openOn: OrderedCollection new


 "
Readers need to understand the dimensions of the scrolling window
provided by a graph pane and how to change them.

This application allows a user to draw rectangles of various sizes.
The user anchors one corner of a rectangle by depressing the left
mouse button, drags the mouse to indicate the position of the other
corner, and releases.  A rubber band indicates the changing shape
of the rectangle as the mouse is being moved.

When drawing a box, the application chooses at random the box's
   border width
   border color
   background color.
This is done as a stand in for the user selecting these and other
attributes from a menu."!

wbCreated

    ^true! !



!ShapeDemo methods !
   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Shape Demo';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 869 @ 520; xC; yC; cRDU: (9 @ 512 rightBottom: 859 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 823 @ 442; xC; yC);
                    noBorders;
                    startGroup;
                    when: #button2Up perform: #onButton2Up:;
                    when: #button1Up perform: #onButton1Up:;
                    when: #button1Down perform: #onButton1Down:;
                    when: #button1Move perform: #onButton1Move:;
                    when: #getContents perform: #drawBoxes:;
                    yourself
            );
        yourself
    ).!
 
drawBoxes: aPane
"Draw boxes in the collection and save instructions for refreshing the images."
    | aPen |

    aPen := aPane pen.
    aPen drawRetainPicture: [
        boxColl do: [:box | box drawWith: aPen]]!
 
onButton1Down: aPane
"When the left mouse button is pressed, position pen to
stretch the rectangle."
    aPane pen place: aPane mouseLocation.
    anchorPoint := aPane mouseLocation.
    lastPosition := aPane mouseLocation!

onButton1Move: aPane
"When the mouse is moved with the left button pressed,
stretch the rectangle with a dashed line style."
   aPane pen
        setForegroundMode: MixRuleXor;
        setLineType: PsDot;
        box: lastPosition;
        box: aPane mouseLocation.
    lastPosition := aPane mouseLocation!
  
onButton1Up: aPane
"When the left mouse button is released, give the pen randomly
chosen colors, draw a filled box as a retained picture, and save
a description of the box in the collection of boxes."
    | aPen |

    aPen := aPane pen.
    aPen drawRetainPicture: [
        self setPen: aPen.
        aPen
            setForegroundMode: MixRuleDefault;
            setLineType: PsSolid;
            boxFilled: aPane mouseLocation].
    boxColl add:
        (ScribbleBox new
            foreColor: aPen foreColor
            backColor: aPen backColor
            lineWidth: aPen lineWidth
            origin: anchorPoint
            corner: aPane mouseLocation)!
  
onButton2Up: aPane
"Find the top box (i.e., the last box) containing the mouse,
remove it from the collection, clear the pane, and redraw
the boxes."

    | aBox |

    boxColl do: [:box | (box containsPoint: aPane mouseLocation)
        ifTrue: [aBox := box]].

    aBox isNil ifFalse: [
        boxColl remove: aBox.
        aPane pen deleteAllSegments.
        aPane pen backColor: ClrWhite.
        aPane erase.
        self drawBoxes: aPane]!
  
openOn: aBoxColl
"Opens a window on a shape drawing application."
    boxColl := aBoxColl.
    super open!
   
setPen: aPen

    | colors widths i j k |

    colors := Array with: ClrBlue with: ClrGreen with: ClrRed.
    widths := #(1 3 5).
    i  := (Time millisecondClockValue rem: 3).
    j  := ((i+1) rem: 3) + 1.
    k := ((i+2) rem: 3) + 1.
    i := i + 1.
    aPen
        foreColor: (colors at: i);
        backColor: (colors at: j);
        setLineWidth: (widths at: k)! !
