
ViewManager subclass: #Sketchpad2
  instanceVariableNames: 
    'penWidth penColor penWidthMenu penColorMenu '
  classVariableNames: ''
  poolDictionaries: 
    'ColorConstants DrawingModeConstants '  !


!Sketchpad2 class methods ! !



!Sketchpad2 methods !
   
onButton1Down: aPane
    "Prepares pen to draw when left mouse button is pressed."
    aPane pen
        down;            "Just in case the pen is up"
        place: aPane mouseLocation!
  
onButton1Move: aPane
    "Draws line when mouse is moved with left button pressed and saves 	instructions."
    | aPen |
    aPen := aPane pen.
    aPen drawRetainPicture: [
           aPen
                foreColor: penColor;
                setLineWidth: penWidth;
                goto: aPane mouseLocation.]!
 
onButton1Up: aPane
    "Nothing to do"!

open

    self labelWithoutPrefix: 'Sketchpad2'.

    penColor := ClrBlack.
    penWidth := 1.

    self addSubpane: (
        GraphPane new
            owner: self;
            when: #button1Down perform: #onButton1Down:;
            when: #button1Up perform: #onButton1Up:;
            when: #button1Move perform:   #onButton1Move:;
            framingRatio: (0.0 @ 0.0 extent: 1 @ 1)).

    self mainView menuWindow addMenu: (penWidthMenu :=
        Menu new
            title: 'Width';
            owner: self;
            appendItem: '1' selector: #setWidth1;
            appendItem: '5' selector: #setWidth5
        ).
    penWidthMenu checkItem: #setWidth1.

    self mainView menuWindow addMenu: (penColorMenu :=
        Menu new
            title: 'Color';
            owner: self;
            appendItem: 'Black' selector: #setBlack;
            appendItem: 'Blue' selector: #setBlue;
            appendItem: 'White' selector: #setWhite
        ).
    penColorMenu checkItem: #setBlack.

    self openWindow!

setBlack
    "User has selected black in color menu, so set pen and
    adjust check mark in menu."
    penColor := ClrBlack.
    penColorMenu
        uncheckItem: #setBlue;
        checkItem: #setBlack;
        uncheckItem: #setWhite.!
 
setBlue
    "User has selected blue in color menu, so set pen and
    adjust check mark in menu."
    penColor := ClrBlack.
    penColorMenu
        uncheckItem: #setBlack;
        checkItem: #setBlue;
        uncheckItem: #setWhite.!
   
setWhite
    "User has selected white in color menu, so set pen and
    adjust check mark in menu."
    penColor := ClrWhite.
    penColorMenu
        uncheckItem: #setBlue;
        checkItem: #setWhite;
        uncheckItem: #setWhite.!
 
setWidth1
    "User has selected 1 in width menu, so set pen and adjust check mark in 	menu."
    penWidth :=  1.
    penWidthMenu
        uncheckItem: #setWidth5;
        checkItem: #setWidth1.!

setWidth5
    "User has selected 5 in width menu, so set pen and adjust check mark in 	menu."
    penWidth :=  5.
    penWidthMenu
        uncheckItem: #setWidth1;
        checkItem: #setWidth5.! !
