"
******************************************************************************
Application : Smalltalk Express Fixes
Date        : Sep 20, 1996
Time        : 00:50:27

Introduction
============

Fixes:

o Float emulator DLL not released properly
o Walkback on save in WBPro
o Extra exclamation point generated on class file out



Description
===========

Classes : 

Methods : 
WindowBuilder>>saveAs
ClassReader>>fileOut:
Float class>>exit

******************************************************************************
"!


!WindowBuilder methods !   
saveAs

        | temp windowType |

    mainPane editedPane isDialog ifTrue: [
        windowType := 'Dialog'.
    ] ifFalse: [ mainPane editedPane isCompositePane ifTrue: [
        windowType := 'CompositePane'
    ] ifFalse: [
        windowType := 'Window'.
    ]].

    (temp := (PWindowBuilder wbCreateClassDialog new forWindowType: windowType ) result) notNil ifTrue: [
        editedClass := temp.
        self labelWithoutPrefix: self label.
        self changed: true.
        self saveInternal.
        "(windowType = 'Window') ifTrue: [
            (self menuTitled: 'View') enableAll.
        ]."
    ] ifFalse: [
        ^nil
    ].!   !

!ClassReader methods !   
fileOut: aFileName
        "Write the source for the class (including the class definition,
         instance methods, and class methods) in chunk file format
         to aFileName."
    | aFileStream aMetaClass |
    class isNil ifTrue: [^self].
    aFileName isNil ifTrue: [^self].
    CursorManager execute change.
    aFileStream := File newFile: aFileName.
    aFileStream lineDelimiter: Cr.
    class fileOutOn: aFileStream.
    aFileStream nextChunkPut: ''.
    aMetaClass := class class.
    aMetaClass instanceVariableString = ''
        ifFalse: [
            aFileStream cr; cr.
            aMetaClass fileOutOn: aFileStream.
            aFileStream nextChunkPut: ''].
    (ClassReader forClass: class class) fileOutOn: aFileStream.
    self fileOutOn: aFileStream.
    aFileStream close.
    CursorManager normal change!   !

!Float class methods !   
exit
        "Free the emulator DLL."
    FloatEmulator notNil
        ifTrue: [FloatEmulator free].!    !

